#pragma once
#include "Entity.h"
#include "EntityStateGravity.h"
#include "EntityStateSplash.h"
#define CS_ENEMY_SHRIMP_CREATENAME L"CS_enemy_shrimp"
//µÐÈË£ºÏº
class CS_Enemy_Shrimp :
    public Entity
{
public:
    CS_Enemy_Shrimp();
    void Init(std::weak_ptr<Entity> self) override;
    void Step() override;
    void SetState(int stateID, int lr) override;
    void Attack(std::weak_ptr<Entity> dst, int* outDamage, float* outAngle, bool* outTakedown, int* outElemType, float* outShockForce, float* outHeavy) override;
    bool Hurt(std::weak_ptr<Entity> src, int getDamage, float angle, bool bTakedown, int elemType, float shockForce, float heavy, int* outRealDamage) override;
    void Dash();
    void SetAction();
    EntityStateGravity stateGravity;
    EntityStateSplash stateSplash;
    bool bSleep = true;
    int wake_counter = 0;
    int wake_counter_max = 20;
    int sleep_counter = 0;
    int sleep_counter_max = 20;
    int flash_counter = 0;
    int dash_counter = 0;
    int dash_counter_max = 3;
    int dash_interval_counter = 0;
    int dash_interval_counter_max = 60;
};

std::shared_ptr<Entity> CreateCS_Enemy_Shrimp();